import _ from 'lodash';
import { listenProps } from './JqComponent';
import { COMPONENT_ROUTER } from './const';

var store = {};

export const setRouters = (routers) => {
  store.routers = routers;
};

export const getRouters = () => {
  return store.routers;
}

function mountedComponet($, routers, base = '') {
  $.el.html('');
  let hash = location.hash;
  hash = hash.replace('#', '');

  const hasParentRouter = $.el.parent().closest(`[${COMPONENT_ROUTER}]`).attr(COMPONENT_ROUTER);

  for (let router of routers) {
    let { path, component, children } = router;
    let fullPath = `${base}${path}`;
    if (_.startsWith(hash, fullPath)) {
      if (hasParentRouter) {
        // 嵌套路由，继续找子路由
        if (_.isArray(children)) {
          return mountedComponet($, children, fullPath);
        }
      }
      $.el.attr(COMPONENT_ROUTER, fullPath);
      $.el.html(component);
      listenProps.emit('all', 'router', { ...router, hash, path: fullPath });
      return;
    }
  }
}

export default {
  template: `<div ${COMPONENT_ROUTER}></div>`,
  ready($) {
    const listener = (evt) => routerChange();

    $.on('destroy', () => window.removeEventListener('hashchange', listener));
    window.addEventListener('hashchange', listener);

    routerChange();

    function routerChange() {
      let routers = getRouters();
      mountedComponet($, routers);
    };
  }
}